function yesno = isidentity(P)

% ISIDENTITY -- check whether numerical matrix is the identity matrix
%
%       yesno = isidentity(P)

% Copyright (c) 2004 by Fritz Keinert (keinert@iastate.edu),
% Dept. of Mathematics, Iowa State University, Ames, IA 50011.
% This software may be freely used and distributed for non-commercial
% purposes, provided this copyright statement is preserved, and
% appropriate credit for its use is given.
%
% Last update: Feb 20, 2004

n = size(P);
% check that P is square and two-dimensional
if (n(1) ~= n(2) | n(1)*n(2) ~= prod(n))
    yesno = 0;
    return
end

yesno = iszero(P - eye(n(1)));
