function yesno = issingular(S)

% ISSINGULAR -- checks whether a numerical matrix is singular
%
%        yesno = issingular(S)

% Copyright (c) 2004 by Fritz Keinert (keinert@iastate.edu),
% Dept. of Mathematics, Iowa State University, Ames, IA 50011.
% This software may be freely used and distributed for non-commercial
% purposes, provided this copyright statement is preserved, and
% appropriate credit for its use is given.
%
% Last update: Feb 20, 2004

% check that S is square and two-dimensional
n = size(S);
if (n(1) ~= n(2) | n(1)*n(2) ~= prod(n))
    yesno = 1;
    return
end

yesno = iszero(det(S));
