function Q = power(P,n)

% POWER -- elementwise power for matrix polynomials
%
%        Q = P.^n
%        Q = power(P,n)
%
% This routine is not meant to be called by the user. It is called by
% Matlab when the expression P.^n is encountered. It takes the
% appropriate power of each element of each coefficient matrix.
%
% I am not sure that this is useful for anything, but I wrote the
% routine for completeness.

% Copyright (c) 2004 by Fritz Keinert (keinert@iastate.edu),
% Dept. of Mathematics, Iowa State University, Ames, IA 50011.
% This software may be freely used and distributed for non-commercial
% purposes, provided this copyright statement is preserved, and
% appropriate credit for its use is given.
%
% Last update: Feb 20, 2004

Q = trim(P);
nn = size(Q.coef);
% the "reshape" construction is necessary because Matlab
% cannot handle three-dimensional symbolic matrices correctly
Q.coef = reshape(Q.coef(:).^n,nn);
