function Q = simplify(P)

% SIMPLIFY -- built-in SIMPLIFY, extended to matrix polynomials
%
%        Q = simplify(P)
%
% The effect is the same as the system built-in SIMPLIFY, applied to each
% coefficient of a matrix polynomial. This only makes sense if P is a 
% symbolic matrix polynomial.

% Copyright (c) 2004 by Fritz Keinert (keinert@iastate.edu),
% Dept. of Mathematics, Iowa State University, Ames, IA 50011.
% This software may be freely used and distributed for non-commercial
% purposes, provided this copyright statement is preserved, and
% appropriate credit for its use is given.
%
% Last update: Feb 20, 2004

Q = P;
if ~isa(Q.coef,'sym')
    return
end

% The "reshape" is necessary since Matlab cannot handle
% three-dimensional symbolic arrays correctly
Q.coef = reshape(simplify(Q.coef(:)),size(Q.coef));
Q = trim(Q);
