function [n1,n2] = size(P,dim)

% SIZE -- size of coefficient matrices of matrix polynomial
%
%        n       = size(P)
%        [n1,n2] = size(P)
%        n       = size(P,dim)
%
% The effect is the same as the system built-in SIZE, applied to
% one of the coefficients of a matrix polynomial.

% Copyright (c) 2004 by Fritz Keinert (keinert@iastate.edu),
% Dept. of Mathematics, Iowa State University, Ames, IA 50011.
% This software may be freely used and distributed for non-commercial
% purposes, provided this copyright statement is preserved, and
% appropriate credit for its use is given.
%
% Last update: Feb 20, 2004

n = size(P.coef);

if (nargin > 1)
    n1 = n(dim);
else
    if (nargout > 1)
	n1 = n(1);
	n2 = n(2);
    else
	n1 = n(1:2);
    end
end

